/*
  binforge - Repository system for Windows
  Copyright (C) 2009 Younes Serraj  Tous droits rservs.

  Ce programme est un logiciel libre ; vous pouvez le redistribuer ou le
  modifier suivant les termes de la GNU General Public License telle que
  publie par la Free Software Foundation : soit la version 3 de cette
  licence, soit ( votre gr) toute version ultrieure.

  Ce programme est distribu dans lespoir quil vous sera utile, mais SANS
  AUCUNE GARANTIE : sans mme la garantie implicite de COMMERCIALISABILIT
  ni dADQUATION  UN OBJECTIF PARTICULIER. Consultez la Licence Gnrale
  Publique GNU pour plus de dtails.

  Vous devriez avoir reu une copie de la Licence Gnrale Publique GNU avec
  ce programme ; si ce nest pas le cas, consultez :
  <http://www.gnu.org/licenses/>.
*/

#ifdef BINFORGE_H
#ifndef PACKAGES_C
#define PACKAGES_C

int pkg_make(package *pkg, char *name, char *filename, int vmaj, int vmin, int vcor, int vbui) {
	sprintf(pkg->name, "%s\0", name);
	sprintf(pkg->filename, "%s\0", filename);
	pkg->version[0] = vmaj;
	pkg->version[1] = vmin;
	pkg->version[2] = vcor;
	pkg->version[3] = vbui;
	pkg->released_on = time(NULL);
	memcpy(&(pkg->updated_on), &(pkg->released_on), sizeof(time_t));
}

int pkg_add(package *pkg, char *filepath) {
	if (file_exists(filepath) == false)
		return false;
		
	pkg->id = pkgdb_lastid() + 1;
	pkg->size = file_size(filepath);
	
	pkg->released_on = time(NULL);
	memcpy(&(pkg->updated_on), &(pkg->released_on), sizeof(time_t));
	
	if (pkg->size <= 0)
		return false;
	
	if (pkgr_add(pkg->id, filepath) == false) {
		return false;
	}
	
	if (pkgdb_add(pkg) == false) {
		pkgr_delete(pkg->id);
		return false;
	}
	
	return true;
}

int pkg_update(package *pkg) {
	return pkgdb_update(pkg);
}

int pkg_exists(int pkg_id) {
	if (pkgr_exists(pkg_id) == false || pkgdb_exists(pkg_id) == false)
		return false;
	return true;
}

void pkg_print(package *pkg) {
	printf("id: %d\n", pkg->id);
	printf("name: %s\n", pkg->name);
	printf("filename: %s\n", pkg->filename);
	printf("version: %d.%d.%d.%d\n",
		pkg->version[0], pkg->version[1], pkg->version[2], pkg->version[3]);
	printf("size: %d octets\n", pkg->size);
	printf("released on: ");
	printf(ctime(&(pkg->released_on)));
	printf("updated on: ");
	if (difftime(pkg->updated_on, pkg->released_on) == 0)
		printf("(never).\n");
	else
		printf(ctime(&(pkg->updated_on)));
	printf("\n");
}

/*int pkg_delete(int pkg_id) {
	if (pkgr_delete(pkg_id) == false || pkgdb_delete(pkg_id) == false)
		return false;
	return true;
}*/

#endif PACKAGES_C
#endif BINFORGE_H
